// integ.C - Definicija funkcije za raunanje odreenog integrala.

#include "integ.h"

double Funkcije::integral(const Fun& f, double a, double b) {
  const int BR_INTERVALA = 30;
  try {                                        // Pokuaj tanog raunanja.
    return f.I(b) - f.I(a);
  } catch (G_nema_int) {                       // Priblino raunanje.
    double dx = (b - a) / BR_INTERVALA, s = 0;
    for (int i=0; i<BR_INTERVALA; i++) s += f(a+i*dx);
    return s * dx;
  }
}

