// izvor.h - Klasa izvora elektrine energije.

#ifndef _izvor_h_
#define _izvor_h_

#include "potrosac1.h"
#include <iostream>
using namespace std;
 
namespace Potrosaci {
  class G_indeks{};                // KLASA GREAKA: Indeks izvan opsega.
  inline ostream& operator<<(ostream& it, const G_indeks&)
    { return it << "*** Nedozvoljen indeks! ***"; }

  class G_preopt {};               // KLASA GREAKA: Preoptereen izvor.
  inline ostream& operator<<(ostream& it, const G_preopt&)
    { return it << "*** Preopterecen izvor! ***"; }

  class Izvor {                                 // KLASA IZVORA:
    Potrosac** niz;                             // Niz potroaa. 
    int kap;                                    // Broj prikljunih mesta.
    double sna, opt;               // Nazivna snaga i trenutno optereenje.
  public:
    Izvor(double s, int k);                     // Stvaranje izvora.
    Izvor(const Izvor&) =delete;                // Ne sme da se kopira.
    Izvor& operator=(const Izvor&) =delete;     // Ne sme da se dodeljuje.
    ~Izvor();                                   // Unitavanje izvora.
    double snaga() const { return sna; }        // Nazivna snaga izvora.
    double opterecenje() const { return opt; }  // Trenutno optereenje.
    int brMesta() const { return kap; }         // Broj prikljunih mesta.
    Izvor& prikljuci(Potrosac* p, int i);       // Prikljuivanje potroaa.
    friend ostream& operator<<(ostream& it, const Izvor& izv); // Pisanje.
  }; // class
} // namespace

#endif

