// kvadrat.h - Klasa kvadrata u ravni.

#ifndef _kvadrat_h_
#define _kvadrat_h_

#include "figura1.h"

class Kvadrat: public Figura {
  Real a;                                            // Stranica kvadrata.
public:
  Kvadrat(Real aa=1, const Tacka& tt=ORG)            // Stvaranje kvadrata.
    : Figura(tt) { a = aa; }
  Real O() const override { return 4 * a; }          // Obim kvadrata.
  Real P() const override { return a * a; }          // Povrina kvadrata.
  Kvadrat* kopija() const override                   // Kopija kvadrata.
    { return new Kvadrat(*this); }
private:
  void citaj(istream& ut) override                   // itanje kvadrata.
   { Figura::citaj(ut); ut >> a; }
  void pisi (ostream& it) const override {           // Pisanje kvadrata.
    it << "kvadrat ["; Figura::pisi(it);
    it << ", a=" << a << ", O=" << O() << ", P=" << P() << ']';
  }
};

#endif

